
// see us.sh

#ifdef _MSYS_DYNDEF_
#include <_msys/sys/types.h>
#include <_msys/sys/param.h>
#include <_msys/sys/socket.h>
#include <_msys/sys/un.h>
#else
#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/un.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef _MSYS_DYNDEF_
#include "_msys.h"
#endif

#define NSTRS         3            /* no. of strings  */
#define ADDRESS       "us_socket"  /* addr to connect */
#define BUFFER_SIZE   0x200        /* buffer size to save recived data */

main()
{
	char c;
	FILE *fp;
	int s, len, recived;
	struct sockaddr_un saun;
	char buffer[BUFFER_SIZE + 1];
	fd_set fds;
	struct timeval timeout;

#ifdef _MSYS_DYNDEF_
	_msys_init();
#endif

//	printf("0\n");
//	exit(0);

	if ((s = socket(AF_UNIX, SOCK_STREAM, 0)) < 0)
	{
		perror("client: socket");
		exit(1);
	}

	saun.sun_family = AF_UNIX;
	strcpy(saun.sun_path, ADDRESS);
	len = sizeof(saun.sun_family) + strlen(saun.sun_path);

	if (connect(s, (struct sockaddr *) &saun, len) < 0)
	{
		perror("client: connect");
		exit(1);
	}

	/* Set time limit. */
	timeout.tv_sec = 3;
	timeout.tv_usec = 0;

	/* Create a descriptor set containing our two sockets.  */
	FD_ZERO(&fds);
	FD_SET(s, &fds);

	printf("recv\n");
	recived = 0;
	while (select(sizeof(fds)*8, &fds, NULL, NULL, &timeout) > 0)
	{
		len = recv(s, &buffer[recived], BUFFER_SIZE - recived, 0);
		if (len < 0)
		{
			perror("client: recv");
			exit(1);
		}
		else if (len == 0)
		{
			// the server closed the connection
			break;
		}
		
		recived = MIN(recived + len, BUFFER_SIZE);
	}
	buffer[recived] = 0;

	printf("send\n");
	send(s, buffer, len + 1, 0);

//	printf("fputs\n");
//	fp = fdopen(s, "w");
//	fputs("test\n", fp);

	close(s);

	exit(0);
}
